> For the complete documentation index, see [llms.txt](https://docs.auterion.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.auterion.com/app-development/simulation/virtual-skynode/custom-simulation-modes-and-worlds.md).

# Custom simulation modes and worlds

{% hint style="info" %}
This feature is available since virtual FMU 1.7.0
{% endhint %}

Testing new vehicles configurations and simulation environments with various airframes might result in the need to create a custom vehicle to spawn in gazebo (e.g. for a not yet exposed airframe), a new world to run or a new predefined location to use. Therefore, the UI exposed configuration (`config_options.json`) can be modified on your simulated vehicle via ssh. To do so, make:

```
ssh root@10.41.200.1
mountrw
nano /data/app/com.auterion.virtual-fmu/data/config_options.json
```

Then change as you desire and run

```
auterion-cli app restart com.auterion.virtual-fmu
```

to apply the changes.

Possible changes could e.g. be new/other airframes or gazebo models to use, like:

```
    "options": [
...
        {
            "sim_mode": "gz",
            "model_name": "Fixed-Wing",
            "config": {
-                "PX4_SIM_MODEL": "gz_rc_cessna",
+                "PX4_SIM_MODEL": "gz_my_rc_cessna",
                "PX4_SYS_AUTOSTART": "4003"
            }
        }
    ],
```

Or custom presets for start locations like:

```
    "environments":[
...
        {
            "name": "Baylands",
            "world": "baylands",
            "preset_locations": [
                {
                    "name": "Open field runway",
                    "position": [300, 0, 0.01],
                    "orientation": [0, 0, 0]
                }
+                {
+                    "name": "My new location",
+                    "position": [10, 10, 0.01],
+                    "orientation": [0, 0.1, 0]
+                }
            ]
        },
```

{% hint style="warning" %}
Please make sure that the custom model and world files are available under `~/.simulation-gazebo/models` and `~/.simulation-gazebo/worlds` respectively.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.auterion.com/app-development/simulation/virtual-skynode/custom-simulation-modes-and-worlds.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
